# ActionImport

[`ActionImport`] parses the json generated by [Export] and imports it as [Action].


E.g. in [sudo] where `carapace` is executed for argument completion.

```go
carapace.Gen(rootCmd).PositionalCompletion(
	carapace.Batch(
		os.ActionPathExecutables(),
		carapace.ActionFiles(),
	).ToA(),
)

carapace.Gen(rootCmd).PositionalAnyCompletion(
	carapace.ActionCallback(func(c carapace.Context) carapace.Action {
		executable := filepath.Base(c.Args[0])
		args := []string{executable, "export", ""}
		args = append(args, c.Args[1:]...)
		args = append(args, c.CallbackValue)
		return carapace.ActionExecCommand("carapace", args...)(func(output []byte) carapace.Action {
			if string(output) == "" {
				return carapace.ActionValues()
			}
			return carapace.ActionImport(output)
		})
	}),
)
```

[Action]:../action.md
[`ActionImport`]:https://pkg.go.dev/github.com/rsteube/carapace#ActionImport
[Export]:../export.md
[sudo]:https://github.com/rsteube/carapace-bin/blob/84717177317a9c9b1aa0d150d25d1b5c12cf9422/completers/sudo_completer/cmd/root.go
